#include "fcitxinterface.h"

#define SogouIm "sogouimebs"
FcitxInterface::FcitxInterface()
{
    p_fcitxInterface=new QDBusInterface("org.fcitx.Fcitx", "/inputmethod",
                                            "org.fcitx.Fcitx.InputMethod",
                                            QDBusConnection::sessionBus());
    if (!p_fcitxInterface->isValid()) {
        qCritical() << QDBusConnection::sessionBus().lastError().message();
    }
}

bool FcitxInterface::isCurrentIMSogou()
{
    QDBusReply<QString> currentIM = p_fcitxInterface->call("GetCurrentIM");
    qDebug()<<currentIM.isValid();
    if(currentIM.isValid()){
        return currentIM.value()==SogouIm;
    }else{
        qCritical() << "Call GetCurrentIM  failed";
        return false;
    }

}
