#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QGSettings>
#include <stdio.h>
#include <unistd.h>
#include <QDebug>
#include <QtDBus>
#include <QPushButton>
#include <QEvent>
#include <QMouseEvent>
#include "sougouinterface.h"
#include "statusmanagerinterface.h"
#include "fcitxinterface.h"
#include <qtsingleapplication.h>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
private:
    void registerDbusInterface();//注册dbus接口
    void registerGsettingsInterface();//监听gsettings

    bool eventFilter(QObject *watched, QEvent *event);
private slots:
    void onPushButtonClicked();//点击按钮槽函数
public slots:
    void keyboardStatusChange(bool status);//键盘改变槽函数状态

private:
    QPushButton * p_pushButton=nullptr;
    Ui::MainWindow *ui;
    QGSettings *p_styleGsetting=nullptr;

    SougouInterface *sougouInterface = nullptr;
    StatusManagerInterface *statusManagerInterface = nullptr;
    FcitxInterface *fcitxInterface = nullptr;
};
#endif // MAINWINDOW_H
