#include "sougouinterface.h"

SougouInterface::SougouInterface()
{
    //连接搜狗dbus
    QString str = "com.basesogouimebs_service.hotel_";
    QString uid = QString::number(getuid());
    QString displayNumber = QObject::tr("_") + getenv("DISPLAY");
    displayNumber.remove(1, 1); // getenv("DISPLAY"); 有冒号 ：  所以需要去除；
    str.append(uid);
    str.append(displayNumber);

    p_sougouInterface=new QDBusInterface(str, "/",
                                            "com.basesogouimebs_interface_service",
                                         QDBusConnection::sessionBus());
    if (!p_sougouInterface->isValid()) {
        qCritical() << QDBusConnection::sessionBus().lastError().message();
    }
}


void SougouInterface::switchInputToTouchMode()
{
    qDebug()<<"点击";
    // 使用sogou提供的接口
    QDBusReply<bool> reply = p_sougouInterface->call("SwitchInputToTouchMode");
    if (reply.isValid()) {
        qCritical() << "Call SwitchInputToTouchMode  failed";
    }
    qDebug()<<"切换输入法到-软键盘模式";
}

void SougouInterface::showKeyboard(bool status)
{
    p_sougouInterface->call("ShowKeyboard",status);
}


bool SougouInterface::isKeyboardVisible()
{
    QDBusReply<bool> reply = p_sougouInterface->call("IsKeyboardVisible");
    return reply;
}
